import java.io.IOException;



public class Exo3{
    
    public Exo3(){
    }
    
    public String enBinaire(int n){
	String res = "";
        while (n > 0) {
            res = n % 2 + res;
            n = n / 2;
        }
        return n + res;
    }
    
    public long pgcd(long a,long b){
	if(a>b){
	    return pgcd(b,a);
	}
	if(a==0){
	    return b;
	}
	return pgcd(b%a,a);
    }
    
    public long fibR(int n){
	if(n==0 || n==1){
	    return 1;
	}
	return fibR(n-1)+fibR(n-2);
    }
    
    public long fibI(int n){
	long u=1;
	long v=1;
	long tmp;
	for(int i=1;i<n;i++){
	    tmp=u+v;
	    u=v;
	    v=tmp;
	}
	return v;
    }
    
    public long exp(int x,int n){
	if(n==0){
	    return 1;
	}
	return (long)x*exp(x,n-1);
    }
    
    public long expRapide(int x,int n){
	long tmp;
	if(n==0){
	    return 1;
	}
	tmp=expRapide(x,n/2);
	tmp=tmp*tmp;
	if(n%2==0){
	    return tmp;
	}
	return (long)x*tmp;
    }
    
    
    public static void main (String[] args) throws IOException{
	Keyboard keyboard=new Keyboard();
	boolean end=false;
	int a,b,rep,n,p,x;
	Exo3 exo=new Exo3();
	while(!end){
	    System.out.println("");
	    System.out.println("> Que voulez-vous faire ?");
	    System.out.println("  1. Conversion d'un nombre entier en bianire ?");
	    System.out.println("  2. Calculer le pgcd de deux entiers par l'algorithme d'Euclide ?");
	    System.out.println("  3. Calculer un terme de la suite de Fibonacci en recursif ?");
	    System.out.println("  4. Calculer un terme de la suite de Fibonacci en iteratif ?");
	    System.out.println("  5. Calculer une puissance par la methode brute ?");
	    System.out.println("  6. Calculer une puissance par la methode rapide ?");
	    System.out.println("  7. Quitter ?");
	    System.out.print("  Choix : ");
	    rep=keyboard.getInt();
	    System.out.println("");
	    switch(rep){
	    case 1:
		System.out.println("> Conversion en bianire");
		System.out.print("  Donnez n (positif) : ");
		n=keyboard.getInt();
		System.out.println("  "+n+ "en binaire vaut "+exo.enBinaire(n));
		break;
	    case 2:
		System.out.println("> Calcul de pgcd par l'algorithme d'Euclide");
		System.out.print("  Donnez a (positif) : ");
		a=keyboard.getInt();
		System.out.print("  Donnez b (positif) : ");
		b=keyboard.getInt();
		System.out.println("  pgcd("+a+","+b+") vaut "+exo.pgcd(a,b));
		break;
	    case 3:
		System.out.println("> Suite de Fibonacci recursif");
		System.out.print("  Donnez n (positif) : ");
		n=keyboard.getInt();
		System.out.println("  Fib("+n+") vaut "+exo.fibR(n));
		break;
	    case 4:
		System.out.println("> Suite de Fibonacci iteratif");
		System.out.print("  Donnez n (positif): ");
		n=keyboard.getInt();
		System.out.println("  Fib("+n+") vaut "+exo.fibI(n));
		break;
	    case 5:
		System.out.println("> Calcul de la puissance n eme de x par la methode brute");
		System.out.print("  Donnez x : ");
		x=keyboard.getInt();
		System.out.print("  Donnez n (positif) : ");
		n=keyboard.getInt();
		System.out.println("  "+x+"^"+n+" vaut "+exo.exp(x,n));
		break;
	    case 6:
		System.out.println("> Calcul de la puissance n eme de x par la methode rapide");
		System.out.print("  Donnez x : ");
		x=keyboard.getInt();
		System.out.print("  Donnez n (positif) : ");
		n=keyboard.getInt();
		System.out.println("  "+x+"^"+n+" vaut "+exo.expRapide(x,n));
		break;


 	    default:
		end=true;
		break;
	    }
	}
    }
}


