public class FileReversible{
    
    private Noeud premier;
    private Noeud dernier;

    public FileReversible(){
    }

    public void ajouterEnQueue(int el){
	Noeud nouv=new Noeud(el);
	if(premier==null){
	    premier=dernier=nouv;
	}
	else{
	    nouv.setPrec(dernier);
	    dernier=nouv;
	    nouv.getPrec().setSuiv(nouv);
	}
    }

    public int retirerEnQueue(){
	int el=dernier.getVal();
	dernier=dernier.getPrec();
	dernier.setSuiv(null);
	return el;
    }

    public boolean estPresent(int el){
	Noeud cour=premier;
	while(cour!=null){
	    if(cour.getVal()==el){
		return true;
	    }
	    cour=cour.getSuiv();
	}
	return false;
    }

    public void insereKieme(int el,int k){
	Noeud cour=premier;
	for(int i=0;i<k-1;i++){
	    cour=cour.getSuiv();
	}
	Noeud nouv=new Noeud(el);
	nouv.setSuiv(cour);
	nouv.setPrec(cour.getPrec());
	if(cour.getPrec()!=null){
	    cour.getPrec().setSuiv(nouv);
	}
	else{
	    premier=nouv;
	    cour.setPrec(nouv);
	}
    }

    @Override
    public String toString(){
	String str="";
	Noeud cour=premier;
	while(cour!=null){
	    str=str+Integer.toString(cour.getVal())+" ";
	    cour=cour.getSuiv();
	}
	return str;
    }
}